/*
 * copyright (C) 1986 by Larry McVoy
 * MUST be distributed in source form only.
 */
# include	<stdio.h>
# include	<sgtty.h>
# include	<fcntl.h>

static struct sgttyb buf;
static done = 0;

delay(on)
{
    if (on) {
	int flags;
	fcntl(0, F_GETFL, &flags);
	flags &= ~O_NDELAY;
	return fcntl(0, F_SETFL, flags);
    }
    else {
	return fcntl(0, F_SETFL, O_NDELAY);
    }
}

cbreak(on)
{
    if (!done) {
	ioctl(fileno(stdin), TIOCGETP, &buf);
	done++;
    }

    if (on) {
	buf.sg_flags |= CBREAK;
	ioctl(fileno(stdin), TIOCSETP, &buf);
    }
    else {
	buf.sg_flags &= ~CBREAK;
	ioctl(fileno(stdin), TIOCSETP, &buf);
    }
}

echo(on)
{
    if (!done) {
	ioctl(fileno(stdin), TIOCGETP, &buf);
	done++;
    }

    if (on) {
	buf.sg_flags |= ECHO;
	ioctl(fileno(stdin), TIOCSETP, &buf);
    }
    else {
	buf.sg_flags &= ~ECHO;
	ioctl(fileno(stdin), TIOCSETP, &buf);
    }
}
