/*
 * copyright 1988 by Larry McVoy.  All rights reserved.
 * If you redistribute this you must distribute in source form.
 */
#include "term.h"
#include <signal.h>
#include <a.out.h>
#include <ctype.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stream.h>
#include <sys/stropts.h>
#include <sys/strstat.h>
#include <sys/var.h>
#include <sys/utsname.h>
#ifndef UNIX
#define	UNIX		"/unix"
#endif
#ifndef KMEM
#define	KMEM		"/dev/kmem"
#endif
#ifdef M_XENIX
#define	v_nblk4096	v_nblk8192
#endif
#ifndef SAVECNT
#define SAVECNT		121
#endif
#define kbytes(x)	( ((x)+1023) >> 10)

#ifdef M_XENIX
#define nlist xlist
#define n_value xl_value
#define n_name xl_name
struct nlist nl[] = {
#define	NL_STRST	0
	{0,0,0,"_strst"},
#define	NL_RBSIZE	1
	{0,0,0,"_rbsize"},
#define	NL_V		2
	{0,0,0,"_v"},
#define	NL_DBALLOC	3
	{0,0,0,"_dballoc"},
#define	NL_NMBLOCK	4
	{0,0,0,"_nmblock"},
	{0,0,0,(char *) 0},
};
#else
struct nlist nl[] = {
#define	NL_STRST	0
	{"_strst"},
#define	NL_RBSIZE	1
	{"_rbsize"},
#define	NL_V		2
	{"_v"},
#define	NL_DBALLOC	3
	{"_dballoc"},
#define	NL_NMBLOCK	4
	{"_nmblock"},
	{ 0 },
};
#endif

ushort rbsize[NCLASS];
short cnt[NCLASS];
struct dbalcst dballoc[NCLASS];
int total, ndblock, nmblock, fd, sleeptime = 1;
struct var v;
struct strstat strst;

/*
 * It's the main thing...
 */
main(ac, av)
    char** av;
{
    int* p;
    int i;
    int done();

    for (i=1; i<ac; ++i) {
	 if (av[i][0] == '-')
	    if (isdigit(av[i][1]))
		sleeptime = atoi(&av[i][1]);
    }
/*
 * get stuff from kmem
 */
    if (nlist(UNIX, nl))
	error("nlist");
    if ((fd = open(KMEM, 2)) < 0)
	error(KMEM);
    readstuff();
    for (i=0, p= &v.v_nblk4096; i<NCLASS; ndblock += (cnt[NCLASS - ++i] = *p++))
	;
/*
 * screen/mode stuff
 */
    termcap();;
    echo(0);
    cbreak(1);
    delay(0);
    signal(SIGHUP, done);
    signal(SIGINT, done);
    signal(SIGQUIT, done);
    signal(SIGTERM, done);
    screen();
/*
 * display until quit
 */
    for ( ;; ) {
	if (lseek(fd, nl[NL_STRST].n_value, 0) < 0)
	    error("lseek");
	if (read(fd, &strst, sizeof(strst)) != sizeof(strst))
	    error("read");
	dump(&strst);
	for (i=0; i<sleeptime; ++i) {
	    if (input())
		break;
	    sleep(1);
	}
	input();
    }
}

/*
 * look for commands; expect to be in cbreak mode
 */
input()
{
    char c;

    if (read(0, &c, 1) != 1)
	return 0;
    switch (c) {
    case 'c':
	clearstuff();
	return 1;
    case '':
	screen();
	return 1;
    case 'q':
	done();
    case '0': case '1': case '2': case '3': case '4':
    case '5': case '6': case '7': case '8': case '9':
	sleeptime = c - '0';
	Pause();
	return 1;
    case '?':
    case 'h':
	clear();
	tprint("", 0, 0);
	printf("\nOptions are\n");
	printf("\tc\tclear total, max, and fail fields\n");
	printf("\t^L\trefresh the screen\n");
	printf("\tq\tquit\n");
	printf("\tN\twhere N is a number 0..9 for the delay between refresh\n");
	printf("Hit any key to continue....\n");
	while (read(0, &c, 1) != 1)
	    sleep(1);
	screen();
	return 1;
    default:
	return 0;
    }
}

/*
 * clear the total, max, and fail fields
 *
 * N.B. assumes acldat is use, total, max, fail
 * and there are NCLASS+4 acldat's in a strstat
 */
clearstuff()
{
    static int clr[3];
    register i;

    clear();
    lseek(fd, nl[NL_STRST].n_value+sizeof(int), 0);
    for (i=0; i<NCLASS+4; ++i) {
	if (write(fd, clr, sizeof(clr)) != sizeof(clr))
	    perror("write");
	lseek(fd, sizeof(int), 1);
    }
    screen();
}

/*
 * display the "once only" stuff
 */
screen()
{
    char buf[200];
    register i;
    struct utsname u;

    clear();
    uname(&u);
    sprintf(buf, "Host=%s", u.nodename);
    tprint(buf, 50, 0);
# if SAVECNT > 0
    sprintf(buf, "%11s%5s%6s%6s%6s%6s%7s%8s%8s%8s", 
	"Resource", "Cnt", "Use", "Ave10", "Ave30", "Ave60", "Ave120", "Total", 
	"Max", "Fail");
# else
    sprintf(buf, "%11s%5s%10s%8s%8s%8s", 
	"Resource", "Cnt", "Use", "Total", "Max", "Fail");
# endif
    tprint(buf, 0, 2);
    sprintf(buf, "%11s:%4d",  "stream", v.v_nstream);
    tprint(buf, 0, 3);
    sprintf(buf, "%11s:%4d",  "queue", v.v_nqueue); 
    tprint(buf, 0, 4);
    sprintf(buf, "%11s:%4d",  "mblock", nmblock); 
    tprint(buf, 0, 5);
    sprintf(buf, "%11s:%4d",  "dblk totals", ndblock); 
    tprint(buf, 0, 6);
# if SAVECNT > 0
    sprintf(buf, "%4s%4s%4s%4s%6s%6s%6s%6s%7s%8s%8s%8s", 
	"Size", "Cnt", "Med", "Low", "Use", "Ave10", "Ave30", "Ave60", "Ave120", "Total", "Max", "Fail");
# else
    sprintf(buf, "%-4s%4s%4s%4s%4s%6s%8s%8s%8s", 
	"Mem", "Size", "Cnt", "Med", "Low", "Use", "Total", "Max", "Fail");
# endif
    tprint(buf, 0, 8);
    for (total=i=0; i<NCLASS; ++i) {
	register lo = dballoc[i].dba_lo;
	register med = dballoc[i].dba_med;

	total += rbsize[i] * cnt[i];
# if SAVECNT > 0
	sprintf(buf, "%4d %3d %3d %3d", rbsize[i], cnt[i], med, lo);
# else
	sprintf(buf, "%3d %4d %3d %3d %3d", kbytes(rbsize[i] * cnt[i]), 
	    rbsize[i], cnt[i], med, lo);
# endif
	tprint(buf, 0, 9 + i);
    }
    sprintf(buf, "Buffers (used/total) = ");
    tprint(buf, 0, 23);
    Pause();
}

Pause()
{
    char buf[40];

    sprintf(buf, "Pause=%d", sleeptime);
    tprint(buf, 0, 0);
}

# if SAVECNT == 0
/*
 * display the information, called once per second (about)
 *
 * No averaging version
 */
dump(s)
    register struct strstat* s;
{
    char buf[80];
    register i, mem = 0;
    static calls = 0;

    sprintf(buf, "%6d%8d%8d%8d",
	s->stream.use, s->stream.total, s->stream.max, s->stream.fail);
    tprint(buf, 20, 3);
    sprintf(buf, "%6d%8d%8d%8d",
	s->queue.use, s->queue.total, s->queue.max, s->queue.fail);
    tprint(buf, 20, 4);
    sprintf(buf, "%6d%8d%8d%8d",
	s->mblock.use, 
	s->mblock.total, s->mblock.max, s->mblock.fail);
    tprint(buf, 20, 5);
    sprintf(buf, "%6d%8d%8d%8d",
	s->dblock.use, s->dblock.total, s->dblock.max, s->dblock.fail);
    tprint(buf, 20, 6);
    for (i=0; i<NCLASS; ++i) {
	mem += s->dblk[i].use * rbsize[i];
	sprintf(buf, "%6d%8d%8d%8d",
	    s->dblk[i].use, s->dblk[i].total, s->dblk[i].max, s->dblk[i].fail);
	tprint(buf, 20, 9 + i);
    }
    sprintf(buf, "%d/%d Kbytes", kbytes(mem), kbytes(total));
    tprint(buf, 23, 23);
    calls++;
    sprintf(buf, "Calls=%d", calls);
    tprint(buf, 10, 0);
}
# else
/*
 * display the information, called once per second (about)
 *
 * Averaging version
 */
dump(s)
    register struct strstat* s;
{
    char buf[80];
    register i, j, b10, b30, b60, b120, mem = 0;
    static struct strstat pst[SAVECNT];
    static struct strstat sum10, sum30, sum60, sum120;
    static calls = 0;

    j = calls % SAVECNT;
    b10 = (j + SAVECNT - 10) % SAVECNT;
    b30 = (j + SAVECNT - 30) % SAVECNT;
    b60 = (j + SAVECNT - 60) % SAVECNT;
    b120 = (j + SAVECNT - 120) % SAVECNT;
    memcpy(&pst[j], s, sizeof(struct strstat));
    addstrst(s, &sum10);
    addstrst(s, &sum30);
    addstrst(s, &sum60);
    addstrst(s, &sum120);
    if (!calls) {
	mulstrst(&sum10, 10);
	mulstrst(&sum30, 30);
	mulstrst(&sum60, 60);
	mulstrst(&sum120, 120);
	for (i=1; i<SAVECNT; ++i)
	    memcpy(&pst[i], s, sizeof(struct strstat));
    }
    else {
	substrst(&pst[b10], &sum10);
	substrst(&pst[b30], &sum30);
	substrst(&pst[b60], &sum60);
	substrst(&pst[b120], &sum120);
    }
    sprintf(buf, "%6d%6d%6d%6d%7d%8d%8d%8d",
	s->stream.use, 
	sum10.stream.use / 10, sum30.stream.use / 30, sum60.stream.use / 60,
	sum120.stream.use / 120,
	s->stream.total, s->stream.max, s->stream.fail);
    tprint(buf, 16, 3);
    sprintf(buf, "%6d%6d%6d%6d%7d%8d%8d%8d",
	s->queue.use, 
	sum10.queue.use / 10, sum30.queue.use / 30, sum60.queue.use / 60,
	sum120.queue.use / 120,
	s->queue.total, s->queue.max, s->queue.fail);
    tprint(buf, 16, 4);
    sprintf(buf, "%6d%6d%6d%6d%7d%8d%8d%8d",
	s->mblock.use, 
	sum10.mblock.use / 10, sum30.mblock.use / 30, sum60.mblock.use / 60,
	sum120.mblock.use / 120,
	s->mblock.total, s->mblock.max, s->mblock.fail);
    tprint(buf, 16, 5);
    sprintf(buf, "%6d%6d%6d%6d%7d%8d%8d%8d",
	s->dblock.use, 
	sum10.dblock.use / 10, sum30.dblock.use / 30, sum60.dblock.use / 60,
	sum120.dblock.use / 120,
	s->dblock.total, s->dblock.max, s->dblock.fail);
    tprint(buf, 16, 6);
    for (i=0; i<NCLASS; ++i) {
	mem += s->dblk[i].use * rbsize[i];
	sprintf(buf, "%6d%6d%6d%6d%7d%8d%8d%8d",
	    s->dblk[i].use, 
	    sum10.dblk[i].use / 10, sum30.dblk[i].use / 30, 
	    sum60.dblk[i].use / 60, sum120.dblk[i].use / 120,
	    s->dblk[i].total, s->dblk[i].max, s->dblk[i].fail);
	tprint(buf, 16, 9 + i);
    }
    sprintf(buf, "%d/%d Kbytes", kbytes(mem), kbytes(total));
    tprint(buf, 23, 23);
    calls++;
    sprintf(buf, "Calls=%d", calls);
    tprint(buf, 10, 0);
}

/*
 * add a to be, leave result in b
 *
 * N.B. Assumes that elements are ints
 */
addstrst(a, b)
    register alcdat* a;
    register alcdat* b;
{
    register i;

    for (i=sizeof(struct strstat)/sizeof(*a); i--; (b++)->use += (a++)->use)
	;
}

/*
 * subtract a from be, result in b
 */
substrst(a, b)
    register alcdat* a;
    register alcdat* b;
{
    register i;

    for (i=sizeof(struct strstat)/sizeof(*a); i--; (b++)->use -= (a++)->use)
	;
}

/*
 * multiply a by b, result in a
 */
mulstrst(a, b)
    register alcdat* a;
    register int b;
{
    register i;

    for (i=sizeof(struct strstat)/sizeof(*a); i--; (a++)->use *= b)
	;
}
# endif	/* SAVECNT */

/*
 * nasty cleanup
 */
error(s)
    char* s;
{
    perror(s);
    done();
}

/*
 * nice cleanup
 */
done()
{
    echo(1);
    cbreak(0);
    delay(1);
    tprint("", cols -1, lines - 1);
    printf("\n");
    exit(0);
}

/*
 * read all once only stuff from kmem
 */
readstuff()
{
    register i;
    if (!nl[NL_RBSIZE].n_value) {
	printf("%s: no value\n", nl[NL_RBSIZE].n_name);
	exit(1);
    }
    if (!nl[NL_STRST].n_value) {
	printf("%s: no value\n", nl[NL_STRST].n_name);
	exit(1);
    }
    if (!nl[NL_V].n_value) {
	printf("%s: no value\n", nl[NL_V].n_name);
	exit(1);
    }
    if (!nl[NL_DBALLOC].n_value) {
	printf("%s: no value\n", nl[NL_DBALLOC].n_name);
	exit(1);
    }
    if (!nl[NL_NMBLOCK].n_value) {
	printf("%s: no value\n", nl[NL_NMBLOCK].n_name);
	exit(1);
    }
    if (lseek(fd, nl[NL_RBSIZE].n_value, 0) < 0)
	error("lseek");
    if (read(fd, rbsize, sizeof(rbsize)) != sizeof(rbsize))
	error("read");
    if (lseek(fd, nl[NL_V].n_value, 0) < 0)
	error("lseek");
    if (read(fd, &v, sizeof(v)) != sizeof(v))
	error("read");
    if (lseek(fd, nl[NL_DBALLOC].n_value, 0) < 0)
	error("lseek");
    if (read(fd, dballoc, sizeof(dballoc)) != sizeof(dballoc))
	error("read");
    if (lseek(fd, nl[NL_NMBLOCK].n_value, 0) < 0)
	error("lseek");
    if (read(fd, &nmblock, sizeof(nmblock)) != sizeof(nmblock))
	error("read");
}
