/*
 * copyright (C) 1986 by Larry McVoy
 * MUST be distributed in source form only.
 */
# include	"term.h"

char* tgoto();

/*------------------------------------------------------------------15/Dec/86-*
 * init_term - read in the termcap stuff
 *----------------------------------------------------------------larry mcvoy-*/
termcap()
{
    char *cp = getenv("TERM");
    char *foo;
    char garbage[10];
    struct sgttyb tty;

    gtty(1, &tty);
    ospeed = tty.sg_ospeed;
    if (cp == (char *) 0)
	    return -1;
    if (tgetent(term_buf, cp) != 1)
	    exit(1);
    foo = garbage;
    foo = tgetstr("pc", &foo);
    if (foo)
	    PC = *foo;
    foo = clbuf;
    tgetstr("cl", &foo);
    foo = ceolbuf;
    tgetstr("ce", &foo);
    foo = cmbuf;
    tgetstr("cm", &foo);
    lines = tgetnum("li");
    cols = tgetnum("co");
    return 0;
}

/* clear to end of line */
ceol(col, row)
{
    char *foo = tgoto(cmbuf, col, row);

    write(1, foo, strlen(foo));
    tputs(ceolbuf, 1, putchar);
}

/* clear screen */
clear()
{
    tputs(clbuf, lines, putchar);
}

/*------------------------------------------------------------------15/Dec/86-*
* tputchar(c, col, row) - put a single char on the screen
*
* Inputs ----> (char), (int), (int)
*
* Bugs ------> Assumes that the coords make sense
*
* Revisions:   
*----------------------------------------------------------------larry mcvoy-*/
tputchar(c, col, row)
    char c;
{
    register char* foo;

    foo = tgoto(cmbuf, col, row);
    tputs(foo, lines, putchar);
    write(1, &c, 1);
}

/*------------------------------------------------------------------15/Dec/86-*
* tprint(s, col, row) - put a string on the screen
*
* Inputs ----> (char), (int), (int)
*
* Results ---> Puts the string out iff it will fit.
*
* Revisions:   
*----------------------------------------------------------------larry mcvoy-*/
tprint(s, col, row)
    register char* s;
{
    register char* foo;

    if (row > lines  ||  col > cols)
	return -1;

    if (strlen(s) > cols - col)
	return -2;

    foo = tgoto(cmbuf, col, row);
    tputs(foo, lines, putchar);
    return write(1, s, strlen(s));
}

/* fake putchar for tputs */
putchar(c)
char c;
{
    write(1, &c, 1);
}
